;Snake v1.4 - Programming: PA
;
;This is the famous ever-growing snake-game!
;The last few levels are extremely difficult!
;Features a high-score, and a cheat-code to warp levels!
;Compiles for the ti86/z80-machine!
;Extensive comments in Dutch!


;******* ASM-DEFINITIES *******
#define equ =
#define EQU =
#include "ti86asm.inc"
#include "ti86ops.inc"
#include "ti86abs.inc"

nieuw_spel	equ 0			;index voor vlaggen
slang_kapot	equ 1			
volgende_level	equ 2			
spel_actie_vlag	equ 3
nieuw_high	equ 4


;******* BEGIN PROGRAMMA *******
.org   _asm_exec_ram
begin:
  call	init
  call  intro
  call	_getkey				;wacht op toetsaanslag om door te gaan
  cp	kCapL				;vergelijk met "L" (Level)
  jp	nz,level_manager		;nee, speel gewoon nieuw spel
  call	_getkey
  cp	kCapW				;volgende "W" (Warp) ?
  jp	nz,level_manager
  call	_getkey  
  sub	$1c				;de level (1-8)
  ld	(level),a
  call	bereken_snelheid
  ld	a,(init_aantal_levens)		;we starten met 'init_aantal_levens' levens
  ld	(levens),a
  ld	a,$30				;we hebben geen punten
  ld	(punten),a
  ld	(punten+1),a
  ld	(punten+2),a			
  jp	level_manager_slang_kapot	;we starten nieuwe level op met 'slang_kapot'
 

;******* LEVEL-MANAGER *******
level_manager:
  bit	nieuw_spel,(ix)			;zoek uit wat we moeten doen
  jp	nz,level_manager_nieuw_spel
  bit	slang_kapot,(ix)
  jp	nz,level_manager_slang_kapot
  jp	level_manager_volgende_level

level_manager_nieuw_spel:		;start nieuw spel op
  ld	a,(init_aantal_levens)		;we starten met 'init_aantal_levens' levens
  ld	(levens),a
  ld	a,1				;we starten level 1
  ld	(level),a
  call	bereken_snelheid
  ld	a,$30				;we hebben geen punten
  ld	(punten),a
  ld	(punten+1),a
  ld	(punten+2),a			;we starten nieuwe level op met 'slang_kapot'
  jp	level_manager_slang_kapot

level_manager_slang_kapot:		;we starten de level in de variabele 'level' op
  ld	a,(levens)			;tenminste als we nog levens hebben
  cp	0
  jp	z,level_manager_stop
  dec	a				;we starten een leven: 1 leven minder
  ld	(levens),a
  ld	a,0				;we beginnen met 0 opgegeten pakketjes voor de punten
  ld	(punten_level),a		;en met 0 opgegeten pakketjes voor de lengte van de
  ld	(voedsel_teller),a		;snake die er nog zou moeten bijkomen
  call	_clrScrn
  call	clear_veld			;we kuisen de tabel 'veld' op
  call	teken_veld
  ld	a,5				;init posities waar we tekenen
  ld	(_tailRow),a
  ld	(_headRow),a
  ld	a,1
  ld	(_tailCol),a
  ld	(_headCol),a
  ld	a,(init_lengte_snake)		;we tekenen nu de slang linksboven in het veld
  ld	b,a				;'init_lengte_snake' stukjes
level_manager_slang_kapot_h1:
  push	bc
  call	teken_snake			;teken een stukje slang
  pop	bc
  ld	a,(_headCol)			;update de positie waar we moeten tekenen
  add	a,4
  ld	(_headCol),a
  djnz	level_manager_slang_kapot_h1
  sub	4				;terugkeren naar head, 1 plaats te ver gegaan in lus
  ld	(_headCol),a
  ld	hl,veld				;we initialiseren een pointer naar staart
  ld	(tabel_tail_pointer),hl
  ld	(hl),$26			;update tabel: volgend stukje snake ligt rechts
  ld	a,(init_lengte_snake)		;we initialiseren een pointer naar hoofd
  ld	b,a
  dec 	b				;maar we vertrekken van staart dus 'lengte-1'
level_manager_slang_kapot_h2:
  inc	hl
  ld	(hl),$26
  djnz	level_manager_slang_kapot_h2
  ld	(tabel_head_pointer),hl  	;pointer naar hoofd opslaan
  ld	(hl),0				;maar in tabel: de kop kan nog overal heen gaan
  call	_RANDOM				;we gaan 'init_aantal_voedsel'-pakketjes in het
  ld	a,(init_aantal_voedsel)		;veld zetten
  ld	b,a
  ld	hl,_OP1M			;random-bytes halen we hier
level_manager_slang_kapot_h3:
  ld	a,(hl)
  inc	hl				;en verderop
  push	hl				;hl en bc bewaren, vernietigd door 'voeg_voedsel_toe'
  push	bc
  call	voeg_voedsel_toe		;zet voedsel in veld
  pop 	bc
  pop	hl
  djnz  level_manager_slang_kapot_h3
  ld	a,$26				;de (voorlopige) richting waar de snake naartoe gaat,
  ld	(snake_richting),a		;dit verandert nog als we snel een toets inderukken
level_manager_slang_kapot_h4:		;poll en clear buffer van toetsen
  call	_getky
  ld	a,(_OP2M)
  cp	0
  jp	nz,level_manager_slang_kapot_h4
  jp	main_loop			;start het spel

level_manager_volgende_level:
  ld	a,(levens)			;in 'level_manager_slang_kapot' gaat er zodra 1 leven af
  inc	a				;dus doen we er hier 1 bij
  ld	(levens),a
  ld	a,(level)
  cp	8
  jp	z,level_manager_slang_kapot	;level 8 is de hoogste level
  inc	a				;anders 1 hoger
  ld	(level),a
  call	bereken_snelheid
  jp	level_manager_slang_kapot

level_manager_stop:			;spel is gedaan
  bit	nieuw_high,(ix)			;save high-score?
  jp	z,level_manager_stop_gewoon
  call	save_high			;bewaar high-score
level_manager_stop_gewoon:  
  call	_clrScrn
  ld	a,0
  ld	(_penCol),a
  ld	(_penRow),a
  ld	a,2				;initialiseer '_curRow' zodat 'DONE' altijd op
  ld	(_curRow),a 			;dezelfde plaats verschijnt
  ld	hl,exittekst
  call	_vputs
  ld	a,0
  ld	(_penCol),a
  ld	a,6
  ld	(_penRow),a
  ld	hl,punten_tekst
  call	_vputs
  ld	a,(punten)			;punten zijn opgeslagen met de echte cijfer-karakter
  call	_vputmap			;waarden, dus geen $30 optellen
  ld	a,(punten+1)
  call  _vputmap
  ld	a,(punten+2)
  call	_vputmap
  ret


;******* SPEL-ACTIE *******		;hier gebeuren de berekeningen die de voortgang van
spel_actie:				;het spel zelf uitmaken
  ld	hl,(tabel_head_pointer)		;initialiseer hl voor straks
  ld	a,(snake_richting)		;kijk welke richting de speler wil gaan
  cp	$24
  jp	z,spel_actie_links
  cp	$25
  jp	z,spel_actie_boven
  cp	$26
  jp	z,spel_actie_rechts
  jp	spel_actie_onder

spel_actie_links:			;stel hl in op het bord waar we misschien naartoe gaan
  dec	hl				;eentje links van de huidige kop
  ld	(tabel_spel_pointer),hl		;hier bewaren we die pointer
  ld	a,(_headRow)			;initialiseer de rij waar we misschien straks gaan
  ld	(_spelRow),a			;tekenen; er zal eerst nog getest worden of we niet
  ld	a,(_headCol)			;buiten ons veld lopen
  sub	4				;de kolom wordt met 4 verkleind
  ld	(_spelCol),a
  jp	spel_actie_test_grens
spel_actie_boven:
  ld	de,$ffe1			;hier 'trekken we 31 af' van hl door er $ffe1 bij op
  add	hl,de				;te tellen
  ld	(tabel_spel_pointer),hl
  ld	a,(_headRow)			;de grafische-rij-pointer met 4 verkleinen
  sub	4
  ld	(_spelRow),a
  ld	a,(_headCol)
  ld	(_spelCol),a
  jp	spel_actie_test_grens
spel_actie_rechts:			;analoog
  inc	hl
  ld	(tabel_spel_pointer),hl
  ld	a,(_headRow)
  ld	(_spelRow),a
  ld	a,(_headCol)
  add	a,4
  ld	(_spelCol),a
  jp	spel_actie_test_grens
spel_actie_onder:			;analoog
  ld	de,31
  add	hl,de
  ld	(tabel_spel_pointer),hl
  ld	a,(_headRow)
  add	a,4
  ld	(_spelRow),a
  ld	a,(_headCol)
  ld	(_spelCol),a			;ga door naar 'spel_actie_test_grens'
  jp	spel_actie_test_grens

spel_actie_test_grens:			;test of we tegen een grens van het veld botsen
  ld	a,(_spelCol)			;hier zouden we willen naartoe gaan
  cp	$fd				;maar is die niet te ver naar links? De meest linkse,
  jp	z,spel_actie_bots_grens		;toegelaten kolom is kolom 1, min 4 levert $fffd op
  cp	125				;of te ver naar rechts? Meest rechtse: 121
  jp	z,spel_actie_bots_grens		;dus plus 4 levert 125
  ld	a,(_spelRow)
  cp	1				;of proberen we niet te hoog te gaan? Hoogste rij waar
  jp	z,spel_actie_bots_grens		;we naar schrijven: 5, min 4 levert 1 op
  cp	61				;of te laag? Laagste rij waar we schrijven is 57,
  jp	z,spel_actie_bots_grens		;plus 4 levert 61
spel_actie_test_voedsel:		;test of er geen voedsel voor ons ligt
  ld	a,(hl)				;hl wijst naar waar we willen, ligt daar iets?
  cp	1
  jp	z,spel_actie_voedsel		;ja
spel_actie_test_slang:			;ligt er niet een stukje snake voor ons?
  cp	$24
  jp	z,spel_actie_slang
  cp	$25
  jp	z,spel_actie_slang
  cp	$26
  jp	z,spel_actie_slang
  cp	$34
  jp	z,spel_actie_slang		;ga verder met 'spel_actie_weg_is_vrij'
  jp	spel_actie_weg_is_vrij

spel_actie_weg_is_vrij:			;er ligt niets meer dat niet deugt voor ons...
  call  hernieuw_staart  		;eerst staart updaten! Anders misschien eerst kop
  call	hernieuw_kop			;getekend waar staart wordt weggeveegd!
spel_actie_exit:
  ret
  
spel_actie_bots_grens:			;we botsen tegen de grens, en vliegen eruit met 
  call  kaboom				;een 'kaboom'-bericht, we wachten even
  call	_getkey				;we hebben
  pop	bc				;'slang_kapot' gezet, en 'pop bc' (ret-adres moet weg!)
  set	slang_kapot,(ix)		;merk op dat we hier ook naartoe gaan vanuit
  res	nieuw_spel,(ix)			;'spel_actie_slang'!!!!!
  res 	volgende_level,(ix)
  jp	level_manager  

spel_actie_voedsel:			;er ligt voedsel voor ons
  call	_RANDOM				;haal nieuw random-getal
  ld	a,(_OP1M)
  call	voeg_voedsel_toe		;om voedsel toe te voegen
  ld	hl,punten+2			;initialiseren voor 'voeg_punt_toe'
  call	voeg_punt_toe  			;voeg punt toe aan score
  call	punten_versus_high		;vergelijk of high-score gebroken
  bit	nieuw_high,(ix)
  jp	z,spel_actie_voedsel_verder1
  ld	a,(compare_high)		;ja, kopieer de reeds verhoogde high-score uit
  ld	(high),a			;'compare_high' naar 'high_score'
  ld	a,(compare_high+1)
  ld	(high+1),a
  ld	a,(compare_high+2)
  ld	(high+2),a
spel_actie_voedsel_verder1:
  ld	a,(punten_level)		;we zijn 1 minder ver van de volgende level
  inc	a
  ld	(punten_level),a
  ld	hl,init_aantal_punten		;zoveel hebben we er nodig
  cp	(hl)
  jp	nz,spel_actie_voedsel_verder2
  set	volgende_level,(ix)		;we gaan naar de volgende level
  res	nieuw_spel,(ix)
  res	slang_kapot,(ix)
  pop	bc
  jp	level_manager			;start!
spel_actie_voedsel_verder2:  
  ld	hl,voedsel_teller		;we gaan nog even voort moeten doen
  ld	a,(init_voedsel_grootte)	
  add	a,(hl)				;we tellen de 'grootte' van het voedselpakket bij de
  ld	(voedsel_teller),a		;waarde 'voedsel_teller' = hoeveel groter we nog moeten
  jp	spel_actie_weg_is_vrij  	;worden
  
spel_actie_slang:			;kijk of het kwaad kan of er een stukske slang voor ons
  ld	de,(tabel_tail_pointer)		;vertoeft: het is ok als het de staart is en er geen
  ld	a,h				;stuk bijkomt in de volgende stap
  cp	d				;dus vergelijk hl met 'tabel_tail_pointer'
  jp	nz,spel_actie_bots_grens
  ld	a,l
  cp	e
  jp	nz,spel_actie_bots_grens      
  ld	a,(voedsel_teller)		;en kijk of 'voedsel_teller' wel op 0 staat
  cp	0
  jp	nz,spel_actie_bots_grens
  jp	spel_actie_weg_is_vrij  	;als dat allemaal ok is -> weg is vrij


;******* LOSSE PROCEDURES *******
voeg_voedsel_toe:			;vernietigt o.a. de, a moet random getal zijn
  call	bereken_voedsel_pointers	;bereken de pointer 'de' in de tabel 'veld' en eveneens
  ld	hl,veld-32			;'_voedselCol' en '_voedselRow' voor 'teken_voedsel'
  add	hl,de				;'de' was 32 te groot, dus tellen we op bij een pointer
  ld	a,(hl)				;naar 'veld' die 32 te klein is!!! Uitleg in 
  cp	0				;'bereken_voedsel_pointers'
  jp	z,voeg_voedsel_toe_ok
  call	_RANDOM				;pech, er zit al iets
  ld	a,(_OP1M)
  jp	voeg_voedsel_toe
voeg_voedsel_toe_ok:			;ok, veld op '(hl)' is leeg
  ld	(hl),1  			;nu niet meer, en teken het
  call	teken_voedsel			;aan hand van '_voedselCol' en '_voedselRow'
  ret

bereken_voedsel_pointers:		;bereken een pointer in 'de' waar voedsel misschien komt,
  ld	hl,_voedselRow  		;bereken ook grafische positie voor tekenen van voedsel
  add	a,(hl)				;rekening houden met oude '_voedselRow' om meer 'random'
  push	af				;te zijn, bewaar a voor berekenen van kolom,
  inc	hl				;berekenen van de rij: eerst oude '_voedselCol' in
  add	a,(hl)				;rekening brengen.
  and	$0f				;positie tussen 0 en 15
  inc	a				;1 en 16
  cp	15				;splits 15 en 16 af
  jp	m,bereken_voedsel_pointers1	
  dec	a				;15 en 16 worden resp. 13 en 14
  dec	a
bereken_voedsel_pointers1:
  ld	(_voedselRow),a 		;bewaar getal tussen 1 en 14 eventjes hier
  pop	af				;bereken nu een kolom
  neg					;extra random
  and	$1f				;5 bits filteren, resultaat tussen 0 en 31
  inc	a				;1 en 32
  cp	32				;splits 32 af
  jp	m,bereken_voedsel_pointers2
  dec	a				;32 wordt 31
bereken_voedsel_pointers2:
  ld	(_voedselCol),a			;bewaar getal tussen 1 en 31 eventjes hier
  ld	b,a  				;werk verder met deze waarde
  ld	hl,0				;we berekenen de offset de we straks bij 'veld' optellen
bereken_voedsel_pointers_h1:
  inc	hl				;per kolom wordt hl 1 groter
  djnz	bereken_voedsel_pointers_h1	;merk op: hl is 1 te groot! (zie later)
  ld	a,(_voedselRow)			;werk met de waarde van de rij
  ld	b,a
  ld	de,31				;per rij wordt hl 31 groter
bereken_voedsel_pointers_h2:
  add	hl,de
  djnz	bereken_voedsel_pointers_h2	;merk op: hl is nog eens 31 extra te groot! (zie later)
  ld	d,h				;bewaar het resultaat in de
  ld	e,l
  ld	a,(_voedselCol)			;bereken de correcte '_voedselCol' en '_voedselRow'
  ld	b,a
  ld	a,$fd				;a maken we bij voorbaat 4 te klein, omdat we er toch 4
bereken_voedsel_pointers_h3:		;teveel gaan bijtellen, we doe niet 'dec b' en 'ld a,1'
  add   a,4				;omdat anders misschien b = 0 wordt -> te grote lus!!!
  djnz	bereken_voedsel_pointers_h3	;we tellen aldus een aantal keer 4 op bij a, die
  ld	(_voedselCol),a	   		;correspondeert met eerste kolom-positie in het veld
  ld	a,(_voedselRow)
  ld	b,a
  ld	a,1				;idem als hierboven: maak a op voorhand 4 te klein, dus 1
bereken_voedsel_pointers_h4:		
  add	a,4				
  djnz	bereken_voedsel_pointers_h4
  ld	(_voedselRow),a			;merk op dat 'de' 32 te groot is, dit wordt opgevangen
  ret					;in 'voeg_voedsel_toe'

bereken_snelheid:			;bepaal hoeveel keer 'halt' wordt uitgevoerd
  ld	a,(level)			;afhankelijk van de 'level'...
  ld	b,a
  ld	a,49				;...beginnen we vanaf 49 keer...
bereken_snelheid_loop:
  sub	6				;...en trekken een 'level' aantal keer 6 ervan af...
  djnz	bereken_snelheid_loop		;...dan is voor level 8 de waarde precies 1...
  ld	(level_snelheid),a		;...maar in 'main_loop_halt' maakt djnz dat 0
  ret

main_loop:				
  call	teken_stats			;schrijf level, levens, score en high-score uit
  ld	a,(level_snelheid)
  ld	b,a
main_loop_halt:
  halt
  djnz	main_loop_halt
  call	_getky				;kijk of er een toets is ingedrukt
  ld	a,(_OP2M)
  cp	0
  jp	z,main_loop_actie		;nee, doe verder met 'spel_actie'
  call	verwerk_input			;ja, verwerk input
main_loop_actie:
  call 	spel_actie   			;voer 'spel_actie' uit
  jp	main_loop

verwerk_input:
  cp	$11				;$11 is pauze
  jp	z,verwerk_input_pauze
  cp	$24				;er is een richting aangegeven voor de slang
  jp	z,verwerk_input_snake_links
  cp	$25
  jp	z,verwerk_input_snake_boven
  cp	$26
  jp	z,verwerk_input_snake_rechts
  cp	$34
  jp	z,verwerk_input_snake_onder
verwerk_input_andere_input:		;het is een andere input
  ret					;misschien per ongeluk toets ingedrukt -> gewoon terug	
verwerk_input_pauze:			
  call	teken_pauze_bericht  
  call	_getkey				;wachten op een toets om te stoppen met de pauze
  call	veeg_lijn_weg			;veeg pauze-bericht weer weg
verwerk_input_pauze_herhaal:		;en pollen/clearen alle input; we willen immers niet
  call	_getky				;dat er iets overblijft dat de volgende keer
  ld	a,(_OP2M)			;geinterpreteerd wordt
  cp	0
  jp	nz,verwerk_input_pauze_herhaal
  ret
verwerk_input_snake_links:
  ld	a,(snake_richting)		;kijk welke richting je nu uitgaat
  cp	$26
  jp	z,verwerk_input_snake_einde	;als je rechts ging, mag je geen rechtsomkeer maken
  ld	a,$24
  ld	(snake_richting),a		;anders ga je gewoon links
  ret
verwerk_input_snake_boven:		;analoog
  ld	a,(snake_richting)
  cp	$34
  jp	z,verwerk_input_snake_einde
  ld	a,$25
  ld	(snake_richting),a
  ret
verwerk_input_snake_rechts:		;idem
  ld	a,(snake_richting)
  cp	$24
  jp	z,verwerk_input_snake_einde
  ld	a,$26
  ld	(snake_richting),a
  ret
verwerk_input_snake_onder:		;mutatis mutandis
  ld	a,(snake_richting)
  cp	$25
  jp	z,verwerk_input_snake_einde
  ld	a,$34
  ld	(snake_richting),a
  ret
verwerk_input_snake_einde:		
  ret

hernieuw_staart:			;update pointers naar staart en teken hem	
  ld	a,(voedsel_teller)		;tenzij de slang langer moet worden
  cp	0
  jp	z,hernieuw_staart_even_lang
  dec	a				;eentje minder groter moeten worden
  ld	(voedsel_teller),a
  ret
hernieuw_staart_even_lang:		;staart schuift op
  ld	hl,(tabel_tail_pointer)		
  ld	a,(hl)				;kijk waar het volgende stukje slang staat
  ld	(hl),0				;veeg oud stuk in 'veld' weg
  cp	$24
  jp	z,hernieuw_links
  cp	$25
  jp	z,hernieuw_boven
  cp	$26
  jp	z,hernieuw_rechts
  jp	hernieuw_onder

hernieuw_links:				;update 'tabel_tail_pointer'
  dec	hl
  ld	(tabel_tail_pointer),hl
  ld	a,(_tailCol)			
  ld	(_penCol),a			;we gaan 'veeg_weg' doen op '_penRow' en '_penCol'
  sub	4
  ld	(_tailCol),a			;maar de nieuwe '_tailCol' wordt opgeslagen
  ld	a,(_tailRow)
  ld	(_penRow),a			;'_tailRow' verandert niet
  call	veeg_weg
  ret
hernieuw_boven:				;analoog
  ld	de,$ffe1
  add	hl,de
  ld	(tabel_tail_pointer),hl
  ld	a,(_tailRow)
  ld	(_penRow),a
  sub	4
  ld	(_tailRow),a
  ld	a,(_tailCol)
  ld	(_penCol),a
  call	veeg_weg
  ret
hernieuw_rechts:			;analoog
  inc	hl
  ld	(tabel_tail_pointer),hl
  ld	a,(_tailCol)
  ld	(_penCol),a
  add	a,4
  ld	(_tailCol),a
  ld	a,(_tailRow)
  ld	(_penRow),a
  call	veeg_weg
  ret
hernieuw_onder:				;analoog
  ld	de,31
  add	hl,de
  ld	(tabel_tail_pointer),hl
  ld	a,(_tailRow)
  ld	(_penRow),a
  add	a,4
  ld	(_tailRow),a
  ld	a,(_tailCol)
  ld	(_penCol),a
  call	veeg_weg
  ret

hernieuw_kop:				;nieuwe kop
  ld	hl,(tabel_head_pointer)		;de richting van het volgende stukje opslaan op oude 
  ld	a,(snake_richting)		;pointer
  ld	(hl),a
  ld	hl,(tabel_spel_pointer)		
  ld	(tabel_head_pointer),hl		;nieuwe pointer naar 'head'
  ld	a,(_spelRow)			;ook: nieuwe '_headRow' en '_headCol'
  ld	(_headRow),a
  ld	a,(_spelCol)
  ld	(_headCol),a
  call	teken_snake			;tekenen
  ret

voeg_punt_toe:				;hl te initialiseren op 'punten+2' of 'high+2'!
  ld	a,(hl)
  inc	a				;1 optellen bij eenheden
  ld	(hl),a				;opslaan
  cp	$3a				;kijken of niet te groot
  jp	nz,voeg_punt_toe_exit		
  ld	a,$30				;ja, dus $30 opslaan
  ld	(hl),a
  dec	hl				;en naar tientallen gaan
  ld	a,(hl)
  inc	a				;1 optellen
  ld	(hl),a				;opslaan
  cp	$3a				;te groot?
  jp	nz,voeg_punt_toe_exit
  ld	a,$30				;$30 opslaan
  ld	(hl),a
  dec	hl				;100-tallen
  ld	a,(hl)
  inc	a
  ld	(hl),a
  cp	$3a
  jp	nz,voeg_punt_toe_exit
  ld	a,$39				;9 laten staan!
  ld	(hl),a
voeg_punt_toe_exit:
  ret

punten_versus_high:			;zet vlag als high-score gebroken is!
  ld	a,(high)			;bereken nieuw resultaat in 'compare_high'
  ld	(compare_high),a		;kopieer eerste
  ld	a,(high+1)
  ld	(compare_high+1),a
  ld	a,(high+2)
  ld	(compare_high+2),a
  ld	hl,compare_high+2
  call	voeg_punt_toe			;tel 1 erbij op en vergelijk dan...
  ld	a,(punten)			;eerst 100-tallen vergelijken
  ld	bc,(compare_high)
  cp	c
  jp	nz,punten_versus_high_exit
  ld	a,(punten+1)			;10-tallen
  ld	bc,(compare_high+1)
  cp	c
  jp	nz,punten_versus_high_exit
  ld	a,(punten+2)			;eenheden
  ld	bc,(compare_high+2)
  cp	c
  jp	nz,punten_versus_high_exit
  set	nieuw_high,(ix)
punten_versus_high_exit:
  ret

save_high:				;save high-score
  ld	hl,snake_name
  call	_MOV10TOOP1			;naam init voor kernel
  call	_FINDSYM			
  jp	c,save_high_fout		;ok?
  ld	hl,high-begin+4			;hoe ver ligt 'high' van het 'begin' af?
  add	hl,de				;in de file komen er nog 4 extra systeem-bytes bij, dus
  jp	nc,save_high_verder		;zitten we 4 verder; optellen bij 'de' (resultaat van
  inc	b				;'_findsym'); 1 optellen als overflow voor abs adres
save_high_verder:
  ld	a,b				;set destination
  call  _SET_ABS_DEST_ADDR
  ld	a,0
  ld	hl,high
  call	_SET_ABS_SRC_ADDR		;source
  ld	a,0
  ld	hl,3				;3 bytes kopieren ('high'-score)
  call	_SET_MM_NUM_BYTES
  call	_mm_ldir
  ret
save_high_fout:				;file niet gevonden
  call	_clrScrn
  ld	a,0
  ld	(_penRow),a
  ld	(_penCol),a
  ld	hl,save_high_error
  call	_vputs
  call	_getkey
  ret  


;******* GRAFISCHE PROCEDURES & AANVERWANTEN *******
clear_veld:				;tabel 'veld' leegmaken
  ld	hl,veld
  ld	b,217
  call	clear_veld_subroutine
  ld	b,217
  call	clear_veld_subroutine
  ret

clear_veld_subroutine:
  ld	(hl),0
  inc	hl
  djnz	clear_veld_subroutine
  ret

teken_veld:				;veld tekenen op het scherm
  ld	hl,$fc60			;een offset om ergens in het video-geheugen
  ld	a,$80				;een waarde ($80) te gaan schrijven in de eerste byte
  ld	de,16				;per 16 bytes
  call	teken_veld_subroutine1
  ld	hl,$fc7f			;idem voor de bijna laatste kolom
  ld	a,4				;nml. de 3e laatste kolom
  call	teken_veld_subroutine1
  ld	hl,$fc60			;horizontale lijn 1
  call	teken_veld_subroutine2
  ld	hl,$fff0			;horizontale lijn 2
  call  teken_veld_subroutine2
  ret

teken_veld_subroutine1:
  ld	b,58				;58 puntjes onder elkaar in kolom
teken_veld_subroutine1_loop:
  ld	(hl),a				; a = $80 = 1 puntje op eerste positie
  add	hl,de				;naar volgende rij gaan (16 bytes)
  djnz	teken_veld_subroutine1_loop 
  ret

teken_veld_subroutine2:
  ld	b,15				;15 keer een volle lijn
teken_veld_subroutine2_loop:
  ld	(hl),$ff
  inc	hl
  djnz	teken_veld_subroutine2_loop
  ld	(hl),$fc			;1 keer een stukje lijn
  ret

teken_snake:				;teken 1 stukje snake op positie '_headCol' en '_headRow' 
  ld	a,(_headCol)			;vernietigt o.a. a, hl, de, bc!!!
  ld	(_penCol),a
  ld	a,(_headRow)
  ld	(_penRow),a
  call	save_lijnen			;bewaar twee lijnen, a staat reeds goed
  ld	hl,snake_tekening  
  call	_vputs
  call	restore_lijnen			;zet ze terug
  ret

teken_voedsel:				;teken 1 stukje voedsel op '_voedselCol' en '_voedselRow' 
  ld	a,(_voedselCol)			;vernietigt o.a. a, hl, de, bc!!!
  ld	(_penCol),a
  ld	a,(_voedselRow)
  ld	(_penRow),a
  call	save_lijnen			;bewaar twee lijnen, a staat reeds goed
  ld	hl,voedsel_tekening  
  call	_vputs
  call	restore_lijnen			;zet ze terug
  ret

veeg_weg:				;veeg 1 stukje slang weg op '_penCol' en '_penRow'	
  ld	a,(_penRow)			;vernietigt o.a. a, hl, de, bc!!!
  call	save_lijnen			;bewaar 2 lijnen
  ld	hl,spatie_tekening  
  call	_vputs
  call	restore_lijnen			;zet ze terug
  ret

save_lijnen:				;we bewaren twee horizontale lijnen uit het grafische
  ld	hl,save_lijnen_adres		;scherm, aangezien anders fragmenten weg zouden zijn;
  ld	(hl),a				;nodig: register a = '_penRow'
  ld	a,0  				;vernietigt: o.a. a, hl, de, bc
  rld					;per rij dat a groot is moeten we 16 bytes opschuiven
  ld	l,(hl)				;in grafisch geheugen, dus shift 4 bit met 'rld',
  add	a,$fc				;en tel op bij adres grafisch geheugen,
  ld	h,a				;hl is nu pointer in grafisch geheugen naar de 2 lijnen,
  ld	(save_lijnen_adres),hl		;bewaar dit adres voor later,
  ld	de,save_lijnen_block		;en bewaar 32 bytes (2 lijnen) in 'save_lijnen_block'
  ld	bc,32				;we gebruiken 'save_lijnen_adres' eens voor 'rld' en 
  ldir					;eens voor adres te bewaren
  ret

restore_lijnen:				;vernietigt: o.a. de, hl, bc
  ld	de,(save_lijnen_adres)      
  ld	hl,save_lijnen_block
  ld	bc,32
  ldir
  ret

teken_pauze_bericht:			;schrijf op bovenste lijn 'pauze', reg.: o.a. a, b, hl
  call	veeg_lijn_weg			;er mag niets meer staan
  ld	a,50				;we schrijven in deze kolom
  ld	(_penCol),a
  ld	a,0				;in rij 0
  ld	(_penRow),a
  ld	hl,pauze_tekst
  call	_vputs
  ret

veeg_lijn_weg:				;bovenste lijn leegmaken, reg.: o.a. b, hl
  ld	b,96				;6 rijen van elk 16 bytes pixels
  ld	hl,$fc00			;in grafisch geheugen
veeg_lijn_weg_herhaal:
  ld	(hl),0				;veeg weg
  inc	hl
  djnz  veeg_lijn_weg_herhaal  
  ret

teken_stats:				;lijn uitschrijven met statistieken 
  ld	a,0				;alles klaarmaken ;reg.: o.a. af, de, b, hl
  ld	(_penRow),a
  ld	(_penCol),a
  ld	hl,level_tekst			
  call	_vputs
  ld	a,(level)			;'level': 1-8 correspondeert met $1 tot $8
  add	a,$30				;het symbool voor '1' is echter $30, dus tel erbij
  call	_vputmap      
  ld	a,31
  ld	(_penCol),a
  ld	hl,levens_tekst
  call	_vputs
  ld	a,(levens)
  add	a,$30
  call	_vputmap
  ld	a,59
  ld	(_penCol),a
  ld	hl,punten_tekst
  call	_vputs
  ld	a,(punten)			;punten zijn opgeslagen met de echte cijfer-karakter
  call	_vputmap			;waarden, dus geen $30 optellen
  ld	a,(punten+1)
  call  _vputmap
  ld	a,(punten+2)
  call	_vputmap
  ld	a,99				;de lengte van de score varieert misschien, we willen
  ld	(_penCol),a			;de 'Hi-Sc' steeds op dezelfde plaats zien staan,
  ld	hl,high_tekst			;namelijk kolom 99
  call	_vputs
  ld	a,(high)			;high-score opgeslagen analoog aan de 'punten'
  call	_vputmap
  ld	a,(high+1)
  call	_vputmap
  ld	a,(high+2)
  call	_vputmap
  ld	ix,vlaggen			;restore ix want kapot door '_vputmap'
  ret

kaboom:					;schrijf op bovenste lijn 'kaboom', reg.: o.a. a, b, hl
  call	veeg_lijn_weg			;er mag niets meer staan
  ld	a,45				;we schrijven in deze kolom
  ld	(_penCol),a
  ld	a,0				;in rij 0
  ld	(_penRow),a
  ld	hl,kaboom_tekst
  call	_vputs
  ret


;******* INITIALISATIE & INTRO *******
init:					
  res	indicRun,(iy+indicflags) 	;we initialiseren een aantal systeem-vlaggen
  res	indicOnly,(iy+indicflags)
  res  	textwrite,(iy+new_grf_flgs)  
  ld	ix,vlaggen			;we zetten ix op vlaggen en stellen ze in
  set	nieuw_spel,(ix)			;we willen een nieuw spel
  res	slang_kapot,(ix)		;de slang is niet juist kapot gegaan
  res	volgende_level,(ix)		;we gaan niet naar volgende level
  res	nieuw_high,(ix)			;high-score is (nog) niet gebroken
  ret

intro:					;we schrijven een welkom-bericht uit
  call	_clrScrn
  ld	a,0
  ld	(_penCol),a
  ld	(_penRow),a
  ld	hl,introtekst
  call	_vputs
  ld	a,0
  ld	(_penCol),a
  ld	a,6
  ld	(_penRow),a
  ld	hl,introtekst2
  call	_vputs
  ld	a,0
  ld	(_penCol),a
  ld	a,12
  ld	(_penRow),a
  ld	hl,introtekst3
  call	_vputs
  ret


;******* VARIABELEN *******
snake_name:
.db 0,5,"snake"

introtekst:
.db "Snake  v1.4  -  "
.db "PA               ",0
introtekst2:
.db "Press  any  key  to  "
.db "start  game...",0
introtekst3:
.db "Press  'F1'  to  "
.db "pause  game...",0

exittekst:
.db "Thanks  for  playing  "
.db "Snake  v1.4!!!",0

pauze_tekst:
.db "pause",0

kaboom_tekst:
.db "!KABOOM!",0

save_high_error:
.db "Could  not  save  "
.db "high-score...",0

level_tekst:
.db "Level:",0

levens_tekst:
.db "Lives:",0

punten_tekst:
.db "Score:",0

high_tekst:
.db "Hi:",0

snake_tekening:				;we representeren de slang door 'x'-en
.db "x",0

voedsel_tekening:			;we representeren voedsel door 'o'-en
.db "o",0

spatie_tekening:
.db "   ",0

init_lengte_snake:			;de lengte van een snake bij start van een level
.db 5

init_aantal_voedsel:			;het aantal voedselpakketjes op het veld
.db 8

init_voedsel_grootte:			;hoeveel langer wordt een slang na eten van voedsel
.db 5

init_aantal_punten:			;hoeveel punten zijn nodig voor volgende level
.db 40					;d.i. aantal pakketjes op te eten in 1 leven

init_aantal_levens:			;aantal levens dat we per spel hebben
.db 3

high:					;high-score, in 'ASCII-op-de-TI86', $30 = 0 
.db $30,$30,$30

level:					;welke level gaan we spelen
.db 0

level_snelheid:				;aantal keer halt in de lus, afhankelijk van 'level'
.db 0

levens:					;aantal levens dat we hebben
.db 0

punten:					;aantal punten dat we hebben, wordt opgeslagen als
.db 0,0,0				;'ASCII-op-de-TI86', dus $30 = 0 !!! (Ongeinitialiseerd)

compare_high:				;wordt gebruikt in 'punten_versus_high'
.db 0,0,0

punten_level:				;aantal punten dat we in dit leven verdiend hebben
.db 0					;moet 'init_aantal_punten' worden voor volgende level

snake_richting:				;dit is de richting waarin de snake volgende stap gaat
.db 0

voedsel_teller:				;dit is een teller voor hoeveel voedsel een snake op
.db 0					;heeft: aftellen en iedere keer snake 1 positie langer

tabel_head_pointer:			;pointer in 'veld' naar hoofd van snake
.db 0,0

tabel_tail_pointer:			;pointer in 'veld' naar staart van snake
.db 0,0

tabel_spel_pointer:			;pointer in 'veld' gebruikt in 'spel_actie'
.db 0,0

_tailRow:				;dit zijn grafische pointers, analoog aan '_penRow'
.db 0					;en '_penCol', ze wijzen aan waar we tekenen, resp. de
_tailCol:				;staart en de kop van de snake
.db 0
_headRow:
.db 0
_headCol
.db 0
_spelRow:				;gebruikt in 'spel_actie'
.db 0
_spelCol:
.db 0

_voedselRow:				;op deze posities, analoog aan '_penRow' en '_penCol'
.db 0					;tekenen we dan een voedselpakketje
_voedselCol:
.db 0

vlaggen:				;vlaggen voor berichten aan 'level_manager':
.db 0					;0) start nieuw spel
					;1) de slang is juist kapot gegaan
					;2) ga naar volgende level
					;vlag voor 'spel_actie':
					;3) voer de spel-actie uit
					;vlag voor punten:
					;4) high score gebroken

save_lijnen_adres:			;hier bewaren we eens -)pointer in grafisch geheugen
.db 0,0					;		      -)reg. a voor 'rld'

save_lijnen_block:			;hier bewaren we 2 lijnen uit grafisch geheugen
.block 32

veld:					;het veld in 14 rijen en 31 kolommen
.block 434				;hier slaan we per positie vlnr en vbno een byte op:
 					;0) deze positie is leeg
					;1) hier ligt voedsel
					;$24) stukje slang, volgend stukje ligt links
					;$25) 					boven
					;$26) 					rechts
					;$34)					onder

;******* EINDE PROGRAMMA *******
.end
